#ifndef PARAMETERS_H
#define PARAMETERS_H

#include "common.h"


#define GET_PARAM(name,type,default_val) \
    (params.count(name) ? params[name].as<type>() : ((type) default_val))
#define PARAM_SET(name)	(params.count(name) ? true : false)

#define DIRECTORY      		GET_PARAM("directory",string,"") // to be used with extract features & merge features
#define IMAGE_FILE          GET_PARAM("image",string,"")
#define FEATURE_FILE		GET_PARAM("feature",string,"")
#define CLUSTER_FILE		GET_PARAM("cluster",string,"")
#define INDEX_FILE          GET_PARAM("index",string,"")

#define INPUT_FILE1		GET_PARAM("filein1",string,"")
#define INPUT_FILE2		GET_PARAM("filein2",string,"")
#define OUTPUT_FILE		GET_PARAM("fileout",string,"")

/* Processing */
#define CONVERT_TO_HDF5		PARAM_SET("convert-to-hdf5") // needs feature-file
#define EXTRACT_FEATURES	PARAM_SET("extract-features")
#define MERGE_FEATURES      PARAM_SET("merge-features")
#define QUERY_IMAGE         PARAM_SET("query-image") // needs image-file & index-file
#define CONCAT_FILES        PARAM_SET("concat-files")
#define COUNT_LINES         PARAM_SET("count-lines")

/* Clusters */
#define BUILD_CLUSTERS		PARAM_SET("build-clusters")
#define NUM_CLUSTERS        params["num-clusters"].as<int>()
#define NUM_ITER            params["num-iters"].as<int>()

/* Cluster indexes */
#define BUILD_CLUSTER_INDEX	PARAM_SET("build-cluster-index")
#define LOAD_CLUSTER_INDEX	PARAM_SET("load-cluster-index")


namespace cvflannIndex {

/** Global program parameters */
extern po::variables_map params;

/** Retrieves all of the parameters into the provided map. */
void getParameters(int ac, char* av[]);

/** Prints usage */
void print_usage();

}



#endif // PARAMETERS_H
