HEADERS += \
    camera.h \
    cameraConf.h \
    converter.h \
    feature.h \
    defs.h \
    dictionary.h \
    global.h \
    graph.h \
    imageutils.h \
    image.h \
    index.h \
    simgraph.h \
    simmap.h \
    visapp.h \
    mapwidget.h \
    mainwindow.h \
    imagewidget.h \
    addimagesdialog.h \
    configuration.h \
    imagecomparisonwidget.h \
    point.h \
    common.h \
    imagecomparisonconfig.h \
    progressbar.h \
    mapmergedialog.h \
    astar.h \
    imagecomparisondialog.h \
    vertexinput.h \
    edgeinput.h \
    edgeinputtext.h

SOURCES += \
    camera.cpp \
    converter.cpp \
    addimagesdialog.cpp \
    dictionary.cpp \
    image.cpp \
    imagewidget.cpp \
    imageutils.cpp \
    simgraph.cpp \
    simmap.cpp \
    visapp.cpp \
    main.cpp \
    mainwindow.cpp \
    mapwidget.cpp \
    imagecomparisonwidget.cpp \
    imagecomparisonconfig.cpp \
    mapmergedialog.cpp \
    imagecomparisondialog.cpp \
    edgeinput.cpp \
    vertexinput.cpp \
    edgeinputtext.cpp

INCLUDEPATH += \
    ../common \
    ../Indexing \
    /home/gorkem/sources/siftHess/include \
    /usr/local/include \
    /usr/include/graphviz


LIBS += \
    `pkg-config --libs opencv gdk-2.0 atk` \ # opencv
    -L/usr/local/lib -L/home/gorkem/sources/siftHess/lib -lfeat \ # sift library by Rob Hess
    -lboost_filesystem \
    -lboost_thread \
    -lgvc \                         # Graphviz library
    -lhdf5 \
    -lflamm


OTHER_FILES += \
    camera.conf \
    myConfiguration.conf

# Higher value for debug shows less info
# Timing=0 is timing off, 1 to time map building, 2 to time map merging
DEFINES += _DEBUG=3 _TIMING=2
