#ifndef ADDIMAGESDIALOG_H
#define ADDIMAGESDIALOG_H

#include <QDialog>
#include <QGroupBox>
#include <QListWidget>
#include <QTableWidget>
#include <QComboBox>
#include <QFileDialog>
#include <QtGui>

class AddImagesDialog : public QDialog
{
    Q_OBJECT
public:
    AddImagesDialog(QString title, QString applyString, QWidget *parent = 0);
    QStringList getSelectedFiles() { return files; }
    bool isForced() { return forceCheck->isChecked(); }
    bool addEdges() { return addEdgesCheck->isChecked(); }
    //QString getSelectedMethod() { return method; }
    //void setDirectory(QString dir) { openFilesPath = dir; }
    //QString getDirectory() { return openFilesPath; }

private slots:
    void add();
    void remove();
    void removeAll();
    void apply();
    void updateButtons();
    void addToSidebar();

private:
    QStringList files;
    //QString method;
    QListWidget* imageList;
    QComboBox* methodList;
    QPushButton* applyButton;
    QPushButton* addButton;
    QPushButton* removeButton;
    QPushButton* removeAllButton;

    QCheckBox* forceCheck;
    QCheckBox* addEdgesCheck;

    static QString openFilesPath;

    QFileDialog *addDialog;
};


#endif // ADDIMAGESDIALOG_H
