#include "converter.h"

#include <iostream>
#include <stdlib.h>
#include <sstream>


namespace converter {

    int str2int(const string &s) {
        istringstream myStream(s);
        int i;
        if(myStream >> i)
            return i;
        else {
            cerr<<"Error in converting string to integer: "<<s<<endl;
            exit(-1);
        }
    }

    double str2double(const string &s) {
        istringstream myStream(s);
        double d;
        if(myStream >> d)
            return d;
        else {
            cerr<<"Error in converting string to double: "<<s<<endl;
            exit(-1);
        }
    }

    string int2str(int i) {
        ostringstream myStream;
        myStream << i;
        return myStream.str();
    }

    string double2str(double d) {
        ostringstream myStream;
        myStream << d;
        return myStream.str();
    }

    string trimLeft(const string &s) {
        string d(s);
        return d.erase(0,s.find_first_not_of(" \t\r\n"));
    }

    bool isEmpty(const string &s) {
        string ss = trimLeft(s);
        if(ss=="")
            return true;
        return false;
    }
}
