#ifndef DEFS_H
#define DEFS_H

#include "common.h"
#include "converter.h"
#include <vector>
#include <boost/unordered_map.hpp>
#include <boost/foreach.hpp>
#include <opencv2/core/core.hpp>
#include "configuration.h"

// Descriptor data type
#ifndef DDT
typedef double DDT;
#endif

extern conf::VisAppConf appConf;


typedef unsigned char FT; //featureType
typedef float CT; //clusterType

typedef int wordIndex;
typedef int imageIndex;


typedef vector<cv::Point2d> ZointList;
typedef pair<ZointList,ZointList> ZointMatchList;
typedef boost::unordered_map<imageIndex,ZointMatchList> ZointMatchMap;

//typedef vector<feat::ImagePoint> PointList;
//typedef pair<feat::ImagePoint,feat::ImagePoint> PointMatch;
//typedef vector<PointMatch> PointMatchList;
//typedef boost::unordered_map<imageIndex,PointMatchList> PointMatchMap;
//typedef pair<Feat*,Feat*> FeatureMatch;
//typedef boost::unordered_map<imageIndex,vector<FeatureMatch> > FeatureMatchMap; // <index of the matched image,list of feature matches between query image and this image>



#endif
