#ifndef DICTIONARY_H
#define DICTIONARY_H

#include <vector>
#include <string>
#include "defs.h"
//#include "feature.h"
#include "image.h"
#include "index.h"


typedef boost::unordered_map<imageIndex,ZointList> OccuranceList;

//typedef boost::unordered_map<wordIndex,int> WordList; // map<wordIndex, any info about the word [empty for now]>
typedef boost::unordered_map<wordIndex,OccuranceList> InvIndex; // map<wordIndex,occurances>
//typedef boost::unordered_map<wordIndex,vector<Feat*> > WordHistorgram; // map<wordindex,vector<features>>



class Dictionary
{
public:
    //! Holds all words/features in the database
    //WordList dict;
    InvIndex invIndex;

    Dictionary(string clusterfile, string indexfile);
    ~Dictionary();

    void clear();

    bool isEmpty();
    int size();
    int numWords();

    void addImage(Image *img);
    void findMatches(Image *img, ZointMatchMap &matches);
    void queryDictionary(Image *img, Mat &indices, Mat &distances);

    //! Printout all the occurances in the dictionary
    void print();

    void writeDictionary(string filename);
    void readDictionary(string filename,ImageTable &imageLookup);

private:  
//    flamm::Matrix<float> clusters;
//    flamm_index_t clusterIndex;
//    struct FLAMMParameters indexParams;
    cvflannIndex::Index<FT,CT> *index;

    void writeInvIndex(string filename);
    void readInvIndex(string filename, ImageTable &imageLookup);
};

#endif // DICTIONARY_H
