#include "edgeinputtext.h"
#include <iostream>

using namespace std;

EdgeInputText::EdgeInputText(QDialog *parent) : QDialog(parent)
{
    setWindowTitle(QString("Edge (v1 & v2):"));

    //QIntValidator *ivalidator = new QIntValidator();

    QRegExp rx("(\\(?([<>]=?)?\\d+(&([<>]=?)?\\d+)?\\)?)(\\|\\|\\(?([<>]=?)?\\d+(&([<>]=?)?\\d+)?\\)?)*");
    QRegExpValidator *regvalidator = new QRegExpValidator(rx, 0);

    input1 = new QLineEdit();
    //input1->setValidator(ivalidator);
    input1->setValidator(regvalidator);
    input1->setMaximumSize(100,25);
    input1->setMaxLength(20);
    input1->setCursorPosition(0);
    input1->setVisible(true);

    input2 = new QLineEdit();
    //input2->setValidator(ivalidator);
    input2->setValidator(regvalidator);
    input2->setMaximumSize(100,25);
    input2->setMaxLength(20);
    input2->setCursorPosition(0);
    input2->setVisible(true);

    QHBoxLayout *hbox = new QHBoxLayout;
    hbox->addWidget(input1);
    hbox->addSpacing(10);
    hbox->addWidget(input2);
    setLayout(hbox);

    setFixedSize(QSize(350,50));

    connect(input2,SIGNAL(returnPressed()),this,SLOT(accept()));
}

vector<pair<int,int> > EdgeInputText::getLimits(QString input) {
    vector<pair<int,int> > lims;

    QStringList list = input.split("||");
    foreach (const QString &s, list) {
        QString str(s);
        if(str.startsWith('('))
            str = str.mid(1);
        if(str.endsWith(')'))
            str.chop(1);
        lims.push_back(splitLimits(str));
    }

    return lims;
}

pair<int,int> EdgeInputText::splitLimits(QString s) {
    int low=-1,high=-1;
    QStringList list = s.split("&"); // just assuming there is only 1
    foreach (const QString &str, list) {
        QString n = str.mid(str.indexOf(QRegExp("\\d+"), 0));
        if(str.at(0)=='>') {
            low = n.toInt()+1;
            if(str.at(1)=='=')
                low--;
        }
        else if(str.at(0)=='<') {
            high = n.toInt()-1;
            if(str.at(1)=='=')
                high++;
        }
        else {
            low = n.toInt();
            high = n.toInt();
        }
    }
    return make_pair(low,high);
}
