#ifndef IMAGECOMPARISONCONFIG_H
#define IMAGECOMPARISONCONFIG_H

#include <QWidget>
#include <QtGui>


class ImageComparisonConfig : public QWidget
{
    Q_OBJECT
public:
    ImageComparisonConfig(QWidget *parent = 0);
    int getMethod();
    int getFilter();
    void switchToPairOnlyMode() {
        radioEdge->setEnabled(false);
        radioCustom->setEnabled(false);
        radioPair->setEnabled(true);
        radioPair->setChecked(true);
    }

    void setSubWindowPtr(QMdiSubWindow *s) { subwin = s; }
signals:
    void configChanged();
    void closeSignal();

private slots:
    void updateVisual();
    void closeEvent(QCloseEvent *);
    void close();

private:
    QGroupBox *createMethodGroup();
    QGroupBox *createFilterGroup();

    QGroupBox *groupBoxMethod;
    QGroupBox *groupBoxFilter;

    QRadioButton *radioEdge;
    QRadioButton *radioPair;
    QRadioButton *radioCustom;

    QCheckBox *checkBoxDup;
    QCheckBox *checkBoxFund;
    QCheckBox *checkBoxOut;
    QCheckBox *checkBoxSpa;

    QMdiSubWindow *subwin;
};


#endif // IMAGECOMPARISONCONFIG_H
