#include "imagecomparisondialog.h"
#include <QtGui>
#include <iostream>

using namespace std;

QString ImageComparisonDialog::openFilesPath = QDir::currentPath();

ImageComparisonDialog::ImageComparisonDialog(QWidget *parent) :
        QDialog(parent)
{
    setWindowTitle("Choose two images to compare...");

    //QLabel* descriptionLabel = new QLabel("Choose two images you would like to compare");

    textbox1 = new QLineEdit("Choose 1st image file...");
    textbox2 = new QLineEdit("Choose 2nd image file...");
    textbox1->setReadOnly(true);
    textbox2->setReadOnly(true);
    textbox1->setMinimumWidth(250);
    textbox2->setMinimumWidth(250);

    compareButton = new QPushButton("&Compare");
    compareButton->setEnabled(false);
    selectFile1Button = new QPushButton("...");
    selectFile2Button = new QPushButton("...");
    selectFile1Button->setAutoDefault(true);
    selectFile1Button->setMaximumWidth(30);
    selectFile2Button->setMaximumWidth(30);


    QHBoxLayout *hbox1 = new QHBoxLayout;
    hbox1->addWidget(textbox1);
    hbox1->addSpacing(7);
    hbox1->addWidget(selectFile1Button);

    QHBoxLayout *hbox2 = new QHBoxLayout;
    hbox2->addWidget(textbox2);
    hbox2->addSpacing(7);
    hbox2->addWidget(selectFile2Button);

    QVBoxLayout *vbox = new QVBoxLayout;
    //vbox->addWidget(descriptionLabel);
    vbox->addLayout(hbox1);
    vbox->addLayout(hbox2);
    vbox->addSpacing(15);
    vbox->addWidget(compareButton,0,Qt::AlignCenter);

    setLayout(vbox);
    setFixedHeight(sizeHint().height());

    connect(selectFile1Button, SIGNAL(clicked()), this, SLOT(selectFile1()));
    connect(selectFile2Button, SIGNAL(clicked()), this, SLOT(selectFile2()));
    connect(compareButton, SIGNAL(clicked()), this, SLOT(accept()));
}

void ImageComparisonDialog::selectFile1() {
    QString s = selectFile();
    textbox1->setText(s);
    imageFile1 = s;
    updateButtons();
}

void ImageComparisonDialog::selectFile2() {
    QString s = selectFile();
    textbox2->setText(s);
    imageFile2 = s;
    updateButtons();
}

QString ImageComparisonDialog::selectFile()
{
    QFileDialog::Options options;
    options |= QFileDialog::DontUseNativeDialog;
    QString selectedFilter;
    QString file = QFileDialog::getOpenFileName(
            this,
            tr("Select an image"),
            openFilesPath,
            tr("All image files (*.ppm *.pgm *.jpg *.png)\n"
               "PNG images (*.png)\n"
               "JPG images (*.jpg)\n"
               "PPM images (*.ppm)\n"
               "PGM images (*.pgm)"),
            &selectedFilter,
            options);

    QFileInfo fi(file);
    openFilesPath = fi.absolutePath();
    return file;
}

void ImageComparisonDialog::updateButtons()
{
    if(!imageFile1.isEmpty() && !imageFile2.isEmpty())
        compareButton->setEnabled(true);
    else
        compareButton->setEnabled(false);
}


