#ifndef IMAGEWIDGET_H
#define IMAGEWIDGET_H

#include "image.h"
#include <QWidget>
#include <QLabel>
#include <QAction>
#include <qevent.h>

class ImageWidget : public QWidget
{
    Q_OBJECT
public:
    ImageWidget(QWidget *parent=0);
    ~ImageWidget();
    bool openImage(QString filename);
    bool openImage(Image*);
//    bool saveImage(QString filename, Image::FileFormat fileformat);

    QSize sizeHint () const;
    QSize size () const;
protected:
    void contextMenuEvent(QContextMenuEvent *event);
    void closeEvent(QCloseEvent *);
private slots:
    void imageInfo();
    void showFeatures();
private:
    Image* image;
    QLabel *imageLabel;
    QLabel *imageDescription;

    QAction *imageInfoAct;
    QAction *showFeaturesAct;

    void createActions();
};

#endif // IMAGEWIDGET_H

