#ifndef MAPMERGEDIALOG_H
#define MAPMERGEDIALOG_H

#include <QDialog>
#include <QGroupBox>
#include <QListWidget>
#include <QTableWidget>
#include <QComboBox>
#include <QLineEdit>
#include <QCheckBox>


class MapMergeDialog : public QDialog
{
    Q_OBJECT
public:
    MapMergeDialog(QWidget *parent = 0);
    QStringList getSelectedFiles() { return files; }
    int getSelectedMethod() { return methodList->currentIndex(); }
    int getSelectedStyle() { return styleList->currentIndex(); }
    int getSelectedStopCriteria() { return stopCriteriaList->currentIndex(); }
    double getStopValue();
    int getIter();
    bool isSave() { return saveCheckBox->isChecked(); }

private slots:
    void add();
    void remove();
    void removeAll();
    void merge();
    void moveUp();
    void moveDown();
    void updateButtons();
private:
    QStringList files;

    QListWidget *mapList;
    QComboBox *methodList;
    QComboBox *styleList;
    QComboBox *stopCriteriaList;
    QLineEdit *stopValue;
    QLineEdit *iterValue;
    QCheckBox *saveCheckBox;

    QPushButton *mergeButton;
    QPushButton *addButton;
    QPushButton *removeButton;
    QPushButton *removeAllButton;
    QPushButton *upButton;
    QPushButton *downButton;

    QString openFilesPath;
};

#endif // MAPMERGEDIALOG_H
